import { Channel } from "./Channel";
import { BaseApi } from "./BaseApi";
var BrowserWindowApiEvent;
(function (BrowserWindowApiEvent) {
    BrowserWindowApiEvent["BLUR"] = "event::cn.widgetjs.core.browser-window.blur";
    BrowserWindowApiEvent["FOCUS"] = "event::cn.widgetjs.core.browser-window.focus";
})(BrowserWindowApiEvent || (BrowserWindowApiEvent = {}));
export class BrowserWindowApiImpl extends BaseApi {
    getChannel() {
        return Channel.BROWSER_WINDOW;
    }
    async setIgnoreMouseEvent(ignore) {
        await this.invokeMethod('setIgnoreMouseEvent', ignore);
    }
    async show() {
        await this.invokeMethod('show', true);
    }
    async showInactive() {
        await this.invokeMethod('showInactive', true);
    }
    async hide() {
        await this.invokeMethod('hide', false);
    }
    async center() {
        await this.invokeMethod('center', false);
    }
    async setAlwaysOnTop(alwaysOnTop) {
        await this.invokeMethod('setAlwaysOnTop', alwaysOnTop);
    }
    async isAlwaysOnTop() {
        return await this.invokeMethod('isAlwaysOnTop');
    }
    async openUrl(url) {
        await this.invokeMethod('openUrl', url);
    }
    async moveTop() {
        await this.invokeMethod('moveTop');
    }
    async openDevTools() {
        await this.invokeMethod('openDevTools');
    }
    /**
     * 设置窗口位置
     * @param x
     * @param y
     * @param animation 动画只在mac系统有效
     */
    async setPosition(x, y, animation) {
        await this.invokeMethod('setPosition', x, y, animation);
    }
    async getPosition() {
        return await this.invokeMethod('getPosition');
    }
    async blur() {
        return await this.invokeMethod('blur');
    }
    async focus() {
        return await this.invokeMethod('focus');
    }
    /**
     * 设置窗口是否可以拉伸
     * @param resizable
     */
    async setResizable(resizable) {
        return await this.invokeMethod('setResizable', resizable);
    }
    async getBounds() {
        return await this.invokeMethod('getBounds');
    }
    async setBounds(bounds, animate) {
        return await this.invokeMethod("setBounds", bounds, animate);
    }
    async alignToScreen(align) {
        return await this.invokeMethod('alignToScreen', align);
    }
    async startDraggingWindow() {
        return await this.invokeMethod('startDraggingWindow');
    }
    async stopDraggingWindow() {
        return await this.invokeMethod('stopDraggingWindow');
    }
    /**
     * 通过url检测窗口是否存在
     * @param url
     */
    async existsByUrl(url) {
        return await this.invokeMethod('existsByUrl', url);
    }
}
const BrowserWindowApi = new BrowserWindowApiImpl();
export { BrowserWindowApi, BrowserWindowApiEvent };
